<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="../error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>

<%-- controllo di sicurezza: impedisce l'accesso agli altri utenti --%>
<c:if test="${not (sessionScope.username == 'admin')}">
   	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato ad accedere a questa pagina" />
   	<jsp:forward page="../error.jsp" />
</c:if>

<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />
 
 <c:if test="${not empty param.cat}">
	<%-- associa le features alla classe/categoria selezionata --%>
	<sql:update dataSource="${database}">
	  	INSERT INTO CaratterizzaClasse
	  	VALUES ( ${param.fid}, ${param.cat} );
	</sql:update>
</c:if>

 <c:if test="${not empty param.pid}">
	<%-- associa le features al prodotto selezionato --%>
	<sql:update dataSource="${database}">
	  	INSERT INTO CaratterizzaProdotto
	  	VALUES ( ${param.fid}, ${param.pid}, 
			<c:choose>
				<c:when test="${empty param.grandezza}">
				   NULL
				</c:when>
				<c:otherwise>
					'${param.grandezza}'
				</c:otherwise>
			</c:choose>
	  		);
	</sql:update>
</c:if>

<c:set var="message" scope="request" value="<b>Caratteristica associata correttamente.</b>" />
<jsp:forward page="../message.jsp" />
