<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="../error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>

<%-- controllo di sicurezza: impedisce l'accesso agli altri utenti --%>
<c:if test="${not (sessionScope.username == 'admin')}">
   	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato ad accedere a questa pagina" />
   	<jsp:forward page="../error.jsp" />
</c:if>

<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}?useUnicode=yes&characterEncoding=UTF-8"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<base href="${pageContext.request.scheme}://${pageContext.request.serverName}:${pageContext.request.serverPort}${pageContext.request.contextPath}/" />
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - Associa caratteristica</title>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="../header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="../product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">
  
  	<form action="admin/feat_assoc.jsp" method="POST">
  	
  	Associa caratteristica
  		<select name="fid">
			<sql:query dataSource="${database}" var="result">
				SELECT ID_Caratteristica, Nome
				FROM Caratteristica
			</sql:query>
			<c:forEach var="row" items="${result.rows}">
				<option value="${row.ID_Caratteristica}">${row.Nome}</option>
			</c:forEach>
		</select>
		grandezza (opzionale): <input type="text" name="grandezza" value="">
		<br>
  
  	a classe merceologica
  		<select name="cat">
  			<option value=""></option>
			<sql:query dataSource="${database}" var="result">
				SELECT ID_Classe, Nome
				FROM Classe
			</sql:query>
			<c:forEach var="row" items="${result.rows}">
				<option value="${row.ID_Classe}">${row.Nome}</option>
			</c:forEach>
		</select> (sarà utilizzata per le ricerche)
		<br>
		
	e/o a prodotto
  		<select name="pid">
  			<option value=""></option>
			<sql:query dataSource="${database}" var="result">
				SELECT ID_Prodotto, Nome
				FROM Prodotto
			</sql:query>
			<c:forEach var="row" items="${result.rows}">
				<option value="${row.ID_Prodotto}">${row.Nome}</option>
			</c:forEach>
		</select><br>
		
		<input type="submit" value="Associa" class="button save">
		<input type="reset" value="Annulla" class="button cancel"><br>
	</form>
	
	
  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="../footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
