<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="../error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>

<%-- controllo di sicurezza: impedisce l'accesso agli altri utenti --%>
<c:if test="${not (sessionScope.username == 'admin')}">
   	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato ad accedere a questa pagina" />
   	<jsp:forward page="../error.jsp" />
</c:if>

<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}?useUnicode=yes&characterEncoding=UTF-8"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />
     					
<c:if test="${not (empty param.pid)}">	     
	<sql:query dataSource="${database}" var="result">
		SELECT *
		FROM Prodotto
		WHERE ID_Prodotto = ${param.pid}
	</sql:query>
	
	<c:if test="${empty result.rows}">
	  	<c:set var="errorMessage" scope="request" value="Prodotto non più nel database." />
   	    <jsp:forward page="../error.jsp" />
	</c:if>

	<c:set var="oldID_Fornitore" scope="page" value="${result.rows[0].ID_Fornitore}"/>
	<c:set var="oldID_Classe" scope="page" value="${result.rows[0].ID_Classe}"/>
</c:if>
<%-- altrimenti i dati restano non inizializzati! --%>

<%-- NO? javascript per controllare campi del form richiesti --%>


<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<base href="${pageContext.request.scheme}://${pageContext.request.serverName}:${pageContext.request.serverPort}${pageContext.request.contextPath}/" />
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
	<c:choose>
		<c:when test="${not (empty param.pid)}">
		   <title>${initParam.shopName} - Modifica prodotto - ${result.rows[0].nome}</title>
		</c:when>
		<c:otherwise>
			<title>${initParam.shopName} - Registra nuovo prodotto</title>
		</c:otherwise>
	</c:choose>
	
	
		<%-- usiamo AJAX per aggiornare le caratteristiche a seconda della classe selezionata --%>
		<%-- 
		<script type="text/javascript">
			function showCaratteristiche(str)
			{
				var xmlhttp;    
				if (!str || str=="" || str=="undefined")
				  {
					  document.getElementById("txtHint").innerHTML="(seleziona una categoria)";
					  return;
				  }
				if (window.XMLHttpRequest)
				  {// code for IE7+, Firefox, Chrome, Opera, Safari
				  xmlhttp=new XMLHttpRequest();
				  }
				else
				  {// code for IE6, IE5
				  xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
				  }
				xmlhttp.onreadystatechange=function() {
				  if (xmlhttp.readyState==4 && xmlhttp.status==200)
				    {
				    document.getElementById("txtHint").innerHTML=xmlhttp.responseText;
				    }
				  }
				/*
					else
					{
						document.getElementById("txtHint").innerHTML="nessuna caratteristiche";
					}*/
				xmlhttp.open("GET","admin/feat_list_form.jsp?cat="+str, true);
				xmlhttp.send();
			}
		</script>
		--%>
			
</head>
<body onload="showCaratteristiche(${oldID_Classe})">

<div class="container">
  <div class="header">
  	<%@ include file="../header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="../product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">
  
  	<h1>
	<c:choose>
		<c:when test="${not (empty param.pid)}">
		   Modifica prodotto
		</c:when>
		<c:otherwise>
			Registra nuovo prodotto
		</c:otherwise>
	</c:choose>
	</h1>
	
	<form action="admin/table_edit_row.jsp?table=Prodotto" method="POST">
		<c:if test="${not (empty param.pid)}">
			<%-- inserisce un campo nascosto per ridirezionare il pid dell'oggetto pre-esistente --%>
			<input type="hidden" name="key" value="${param.pid}" />
		</c:if>
		
		<b>Nome*:</b> <input type="text" name="nome" value="${result.rows[0].nome}"><br>
		Descrizione (codice HTML):<br><textarea name="descrizione" style="width:100%;">${result.rows[0].descrizione}</textarea><br>
		<b>Costo (in euro)*:</b> <input type="text" name="costo" value="${result.rows[0].costo}"><br>
		<b>Disponibilità*:</b> <input type="text" name="disponibile" value="${result.rows[0].disponibile}"><br>
		Immagine (URL): <input type="text" name="immagine" value="${result.rows[0].Immagine}" style="width:100%;"><br>
		Immagine 2 (URL): <input type="text" name="immagine2" value="${result.rows[0].Immagine2}" style="width:100%;"><br>
		Immagine 3 (URL): <input type="text" name="immagine3" value="${result.rows[0].Immagine3}" style="width:100%;"><br>
		Immagine 4 (URL): <input type="text" name="immagine4" value="${result.rows[0].Immagine4}" style="width:100%;"><br>
		Immagine 5 (URL): <input type="text" name="immagine5" value="${result.rows[0].Immagine5}" style="width:100%;"><br>
		<%-- ALTERNATIVA: Immagine (file): <input type="file" name ="immagine"><br> --%>
		Video (URL): <input type="text" name="video" value="${result.rows[0].Video}" style="width:100%;"><br>
		Link esterno: <input type="text" name="URL" value="${result.rows[0].URL}" style="width:100%;"><br>
		
		<%-- drop down list per scegliere fornitore e classe merceologica --%>
		Fornitore:	
		<select name="ID_Fornitore">
			<option value=""></option>
			<sql:query dataSource="${database}" var="result">
				SELECT ID_Fornitore, Nome
				FROM Fornitore
			</sql:query>
			<c:forEach var="row" items="${result.rows}">
				<option value="${row.ID_Fornitore}"
				<c:if test="${row.ID_Fornitore==oldID_Fornitore}">
					selected="selected"
				</c:if>
					 >${row.Nome}</option>
			</c:forEach>
			<%-- TODO: javascript: "(Aggiungi nuovo)" -> admin/table_edit_row_form.jsp?table=Fornitore --%>
		</select><br>
	

		Classe merceologica:	
		<select name="ID_Classe" onchange="showCaratteristiche(this.value)">>
			<option value=""></option>
			<sql:query dataSource="${database}" var="result">
				SELECT ID_Classe, Nome
				FROM Classe
			</sql:query>
			<c:forEach var="row" items="${result.rows}">
				<option value="${row.ID_Classe}"
				<c:if test="${row.ID_Classe==oldID_Classe}">
					selected="selected"
				</c:if>
					 >${row.Nome}</option>
			</c:forEach>
			<%-- TODO: javascript: "(Aggiungi nuovo)" -> admin/table_edit_row_form.jsp?table=Classe --%>
		</select><br>
		
		<%--
		Caratteristiche:
			<div id="txtHint">(seleziona una categoria)</div>
			--%>
		
		<input type="submit" value="Salva" class="button save">
		<input type="reset" value="Annulla modifiche" class="button cancel"><br>
	</form>
	
	<b>* campi richiesti</b>

  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="../footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>