<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="../error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>

<%-- controllo di sicurezza: impedisce l'accesso agli altri utenti --%>
<c:if test="${not (sessionScope.username == 'admin')}">
   	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato ad accedere a questa pagina" />
   	<jsp:forward page="../error.jsp" />
</c:if>

<sql:setDataSource var="database"
	 driver="${initParam.databaseDriver}"
	 url="${initParam.databaseUrl}/${initParam.shopName}"
	 user="${initParam.databaseUsername}"
	 password="${initParam.databasePassword}" />
	 	
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<base href="${pageContext.request.scheme}://${pageContext.request.serverName}:${pageContext.request.serverPort}${pageContext.request.contextPath}/" />
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - Controlla magazzino</title>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="../header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="../product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">
		
	<h1>Controlla magazzino</h1>
		     
	<hr>
	
	<h2>Prodotti in esaurimento:</h2>
		<sql:query dataSource="${database}" var="result">
			SELECT ID_Prodotto, Nome, Costo, Disponibile
			FROM Prodotto
			WHERE (Disponibile < 10) AND (Disponibile <> 0) 
			ORDER BY Disponibile ASC
		</sql:query>
		<c:choose>
			<c:when test="${empty result.rows}">
			   <p align="center">Nessun prodotto trovato</p>
			</c:when>
			<c:otherwise>
				<%@ include file="../product_list.inc.jsp" %>
			</c:otherwise>
		</c:choose>
	<br>
	
	<hr>
	
	<h2>Prodotti non più disponibili:</h2>
		<sql:query dataSource="${database}" var="result">
			SELECT ID_Prodotto, Nome, Costo, Disponibile
			FROM Prodotto
			WHERE Disponibile = 0
		</sql:query>
		<c:choose>
			<c:when test="${empty result.rows}">
			   <p align="center">Nessun prodotto trovato</p>
			</c:when>
			<c:otherwise>
				<%@ include file="../product_list.inc.jsp" %>
			</c:otherwise>
		</c:choose>
  	
  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="../footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
