<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="../error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%-- controllo di sicurezza: impedisce l'accesso agli altri utenti --%>
<c:if test="${not (sessionScope.username == 'admin')}">
   	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato ad accedere a questa pagina" />
   	<jsp:forward page="../error.jsp" />
</c:if>


<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<base href="${pageContext.request.scheme}://${pageContext.request.serverName}:${pageContext.request.serverPort}${pageContext.request.contextPath}/" />
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - Statistiche</title>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="../header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="../product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">
  	
  	<c:set var="now" value="<%=new java.util.Date()%>" />
  	 		
	<c:set var="startDate" value="${param.startDate}" />
  	<c:if test="${empty startDate}">
   		<fmt:formatDate pattern="yyyy-MM-dd" value="${now}" var="startDate" />
	</c:if>

	<c:set var="endDate" value="${param.endDate}" />
  	<c:if test="${empty endDate}">
   		<fmt:formatDate pattern="yyyy-MM-dd" value="${now}" var="endDate" />
	</c:if>
	
	<h1>Statistiche<br>
		dal ${startDate}<br>
		al ${endDate}
	<%--
		<fmt:parseDate value="${startDate}" var="startDateObj" pattern="yyyy-MM-dd" />
		<fmt:parseDate value="${endDate}" var="endDateObj" pattern="yyyy-MM-dd" />
		dal <fmt:formatDate type="date" value="${startDateObj}" /><br>
		 al <fmt:formatDate type="date" value="${endDateObj}" />
	 --%>
	<br>
		
	<fmt:formatDate pattern="yyyy" value="${now}" var="this_year" />
	<fmt:formatDate pattern="MM" value="${now}" var="this_month" />
	
	<a href="admin/stats.jsp" class="admin button">odierne</a>
	<%-- TODO? settimanali --%>
	<a href="admin/stats.jsp?startDate=${this_year}-${this_month}-01&endDate=${this_year}-${this_month}-31" class="admin button">mensili</a>
	<a href="admin/stats.jsp?startDate=${this_year}-01-01&endDate=${this_year}-12-31" class="admin button">annuali</a>
	</h1>
	
	<hr>
	
	<h2>
  	 <a href="orders_list.jsp">
		<sql:query dataSource="${database}" var="supply_total">
			SELECT COALESCE(SUM(Totale), 0) AS TotaleForniture
			FROM Ordine
			WHERE (ID_Cliente = 1) AND
			      (Data BETWEEN ${startDate} AND ${endDate})
		</sql:query>
  	 
  	 Costo totale forniture: <c:out value="${supply_total.rows[0].TotaleForniture}"/> &euro;
  	 <br>
		<sql:query dataSource="${database}" var="orders_total">
			SELECT COALESCE(SUM(Totale), 0) AS TotaleOrdini
			FROM Ordine
			WHERE (ID_Cliente <> 1) AND
			      (Data BETWEEN ${startDate} AND ${endDate})
		</sql:query>
  	 Ricavo totale ordini: <c:out value="${orders_total.rows[0].TotaleOrdini}"/> &euro;
  	 <br>
  	 Bilancio: ${orders_total.rows[0].TotaleOrdini - supply_total.rows[0].TotaleForniture} &euro;
  	 <br>
  	 </a></h2>
	
	 <hr>
	 
  	 <h1>Prodotti più venduti:</h1>
	  	 <sql:query dataSource="${database}" var="result">
			SELECT ID_Prodotto, Nome, Costo, Disponibile
			FROM Prodotto
			WHERE ID_Prodotto IN (
									SELECT ID_Prodotto
									FROM
									(
										SELECT ID_Prodotto, COUNT(ID_Prodotto) AS CNT
										FROM Prodotto_Ordinato
										WHERE ID_Ordine IN ( SELECT ID_Ordine
										                     FROM Ordine
										                     WHERE (Data BETWEEN ${startDate} AND ${endDate})
										                    )
										GROUP BY ID_Prodotto
										ORDER BY CNT DESC
										LIMIT 3 <%-- 2FIX: MySQL-only, ALT: SELECT TOP 3 ...--%>
									) AS CNTT
			                     )
		 </sql:query>
		<c:choose>
			<c:when test="${empty result.rows}">
			   <p align="center">Nessun prodotto trovato</p>
			</c:when>
			<c:otherwise>
				<%@ include file="../product_list.inc.jsp" %>
			</c:otherwise>
		</c:choose>
  	 <br></br> 
  	 
	 <hr>
	 
  	 <h1>Prodotti meno venduti:</h1>
	  	 <sql:query dataSource="${database}" var="result">
			SELECT P.ID_Prodotto, Nome, Costo, Disponibile
			FROM Prodotto AS P
			JOIN (
				SELECT P.ID_Prodotto
				FROM Prodotto AS P
				LEFT JOIN
				(
					SELECT ID_Prodotto, COUNT(ID_Prodotto) AS CNT
					FROM Prodotto_Ordinato
					WHERE ID_Ordine IN ( SELECT ID_Ordine
					                     FROM Ordine
					                     WHERE (Data BETWEEN ${startDate} AND ${endDate})
					                    )
					GROUP BY ID_Prodotto
				) AS CNTT ON(CNTT.ID_Prodotto=P.ID_Prodotto)
				ORDER BY CNT ASC
				LIMIT 3
			  ) AS S
				ON P.ID_Prodotto = S.ID_Prodotto
		 </sql:query>
		<c:choose>
			<c:when test="${empty result.rows}">
			   <p align="center">Nessun prodotto trovato</p>
			</c:when>
			<c:otherwise>
				<%@ include file="../product_list.inc.jsp" %>
			</c:otherwise>
		</c:choose>
  	 <br></br>	
	
  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="../footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>

   