<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="../error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>

<%-- controllo di sicurezza: impedisce l'accesso agli altri utenti --%>
<c:if test="${not (sessionScope.username == 'admin')}">
   	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato ad accedere a questa pagina" />
   	<jsp:forward page="../error.jsp" />
</c:if>


<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />

<sql:update dataSource="${database}">
	DELETE FROM ${param.table}
	WHERE ID_${param.table} = '${param.key}'
</sql:update>

<%-- ALTERNATIVA: ottiene la chiave della tabella dall'INFORMATION_SCHEMA
2FIX: cosa fare se la chiave contiene più colonne?
<sql:query dataSource="${database}" var="key_result">
	SELECT k.column_name
	FROM information_schema.table_constraints t
	JOIN information_schema.key_column_usage k
	USING(constraint_name, table_schema, table_name)
	WHERE t.constraint_type='PRIMARY KEY'
	  AND t.table_schema='${initParam.shopName}'
	  AND t.table_name='${param.table}';
</sql:query>
<sql:update dataSource="${database}">
	DELETE FROM ${param.table}
	WHERE ${key_result.rows[0].column_name} = '${param.key}'
</sql:update>
 --%>
 
<%-- se non si sono verificati errori l'operazione è andata a buon fine --%>
<% application.log("row with key \"" + request.getParameter("key") +"\" removed from table \"" + request.getParameter("table") + "\"."); %>
<%--jsp:forward page="table_list.jsp?table=${param.table}"/ --%>
<c:set var="message" scope="request" value="${param.table} cancellato correttamente nel database." />
<jsp:forward page="../message.jsp" />
