<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="../error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>

<%-- controllo di sicurezza: impedisce l'accesso agli altri utenti --%>
<c:if test="${not (sessionScope.username == 'admin')}">
   	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato ad accedere a questa pagina" />
   	<jsp:forward page="../error.jsp" />
</c:if>


<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}?useUnicode=yes&characterEncoding=UTF-8"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />


<%-- cicla i parametri della request e costruisce lo statement SQL dinamicamente --%>
<c:set var="add_comma" value="false"/> <%-- non necessario? Le variabili non definite valgono "false" cmq --%>
<c:choose>
	<c:when test="${empty param.key}">
		<sql:update dataSource="${database}">
			INSERT INTO ${param.table} 
			 (
		   <c:forEach var="currentParam" items="${param}">
		   		<c:if test="${(currentParam.key ne 'table') and (currentParam.key ne 'key')}">
					<c:if test="${add_comma}">, </c:if>
   					${currentParam.key}
   					<c:set var="add_comma" value="true"/> <%-- dopo il primo valore aggiunge sempre la virgola --%>
				</c:if>
		   </c:forEach>
		    ) VALUES ( 
		   <c:set var="add_comma" value="false"/> <%-- NECESSARIO: resetta la variabile a "false" --%>
		   <c:forEach var="currentParam" items="${param}">
		   		<c:if test="${(currentParam.key ne 'table') and (currentParam.key ne 'key')}">
					<c:if test="${add_comma}">, </c:if>
					<%-- replaces empty strings with NULL to enforce NOT NULL constraints --%>
					<c:choose>
						<c:when test="${currentParam.value eq ''}">
						    NULL
						</c:when>
						<c:otherwise>
							<%-- TODO? escape SQL+HTML chars
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, '\'', '\'\'')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, '\"', '&quot;')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, 'à', '&agrave;')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, 'è', '&egrave;')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, 'ì', '&igrave;')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, 'ù', '&ugrave;')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, 'é', '&eacute;')}"/>
							 --%>
							'${currentParam.value}'
						</c:otherwise>
					</c:choose>
					<c:set var="add_comma" value="true"/>
				</c:if>
		   </c:forEach>
		    )
		</sql:update>
	</c:when>
	<c:otherwise>
		<sql:update dataSource="${database}">
			UPDATE ${param.table}
			SET
		   <c:forEach var="currentParam" items="${param}">
		   		<c:if test="${(currentParam.key ne 'table') and (currentParam.key ne 'key')}">
   					<c:if test="${add_comma}">, </c:if>
   					${currentParam.key} = 
   					<%-- replaces empty strings with NULL to enforce NOT NULL constraints --%>
   					<c:choose>
						<c:when test="${currentParam.value eq ''}">
						    NULL
						</c:when>
						<c:otherwise>
							<%-- TODO? escape SQL+HTML chars
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, '\'', '\'\'')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, '\"', '&quot;')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, 'à', '&agrave;')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, 'è', '&egrave;')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, 'ì', '&igrave;')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, 'ù', '&ugrave;')}"/>
								<c:set var="currentParam.value" value="${fn:replace(currentParam.value, 'é', '&eacute;')}"/>
							 --%>
							'${currentParam.value}'
						</c:otherwise>
					</c:choose>
					<c:set var="add_comma" value="true"/>
				</c:if>
		   </c:forEach>
			WHERE ID_${param.table} = '${param.key}'
		</sql:update>
	</c:otherwise>
</c:choose>
 
<%-- se non si sono verificati errori l'operazione è andata a buon fine --%>
<c:choose>
	<c:when test="${empty param.key}">
		<% application.log("row added to table \"" + request.getParameter("table") + "\"."); %>
		<c:set var="message" scope="request" value="<b>${param.table} aggiunto correttamente nel database.</b>" />
	</c:when>
	<c:otherwise>
		<% application.log("row with key \"" + request.getParameter("key") +"\" edited from table \"" + request.getParameter("table") + "\"."); %>
		<c:set var="message" scope="request" value="<b>${param.table} salvato correttamente nel database.</b>" />
	</c:otherwise>
</c:choose>
<%-- jsp:forward page="table_list.jsp?table=${param.table}"/ --%>
<jsp:forward page="../message.jsp" />
