<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="../error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>

<%-- controllo di sicurezza: impedisce l'accesso agli altri utenti --%>
<c:if test="${not (sessionScope.username == 'admin')}">
   	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato ad accedere a questa pagina" />
   	<jsp:forward page="../error.jsp" />
</c:if>


<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}?useUnicode=yes&characterEncoding=UTF-8"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />

<c:choose>
	<c:when test="${empty param.key}">
		<%-- empty query, just to grab column names --%>
		<%-- ALTERNATIVE: query the CATALOG table to get them --%>
		<sql:query dataSource="${database}" var="result">
			SELECT *
			FROM ${param.table}
			WHERE ID_${param.table} = NULL
		</sql:query>
	</c:when>
	<c:otherwise>
		<sql:query dataSource="${database}" var="result">
			SELECT *
			FROM ${param.table}
			WHERE ID_${param.table} = '${param.key}'
		</sql:query>
		<c:if test="${empty result.rows}">
			<c:set var="errorMessage" scope="request" value="Item does not exist" />
   			<jsp:forward page="../error.jsp" />
		</c:if>
	</c:otherwise>
</c:choose>


<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<base href="${pageContext.request.scheme}://${pageContext.request.serverName}:${pageContext.request.serverPort}${pageContext.request.contextPath}/" /> 
<link href="theme/style.css" rel="stylesheet" type="text/css">
<c:choose>
	<c:when test="${empty param.key}">
		<title>${initParam.shopName} - Aggiungi ${param.table}</title>
	</c:when>
	<c:otherwise>
		<title>${initParam.shopName} - Modifica ${param.table}</title>
	</c:otherwise>
</c:choose>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="../header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="../product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">

	<h1>
	<c:choose>
		<c:when test="${empty param.key}">
			Aggiungi ${param.table}
		</c:when>
		<c:otherwise>
			Modifica ${param.table}
		</c:otherwise>
	</c:choose>
	</h1>
	
	<c:choose>
		<c:when test="${empty param.key}">
			<form method="POST" action="admin/table_edit_row.jsp?table=${param.table}">
		</c:when>
		<c:otherwise>
			<form method="POST" action="admin/table_edit_row.jsp?table=${param.table}&key=${param.key}">
		</c:otherwise>
	</c:choose>

   <c:set var="skippedColumnName" scope="page" value="ID_${param.table}"/>
   <c:forEach var="columnName" items="${result.columnNames}">
   		<c:if test="${columnName ne skippedColumnName}">
       		<c:out value="${columnName}"/>: <input type="text" name="${columnName}" value="${result.rows[0][columnName]}"><br>
       	</c:if>
   </c:forEach>
   
   <%-- TODO? ridirezionare i parametri preesistenti --%>
   
	<input type="submit" value="Salva" class="button save">
	<input type="reset" value="Annulla modifiche" class="button cancel"><br>
</form>

  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="../footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
