<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="../error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>

<%-- controllo di sicurezza: impedisce l'accesso agli altri utenti --%>
<c:if test="${not (sessionScope.username == 'admin')}">
   	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato ad accedere a questa pagina" />
   	<jsp:forward page="../error.jsp" />
</c:if>

<c:if test="${empty param.table}">
   	<c:set var="errorMessage" scope="request" value="Nessuna tabella specificata" />
   	<jsp:forward page="../error.jsp" />
</c:if>

<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />

<sql:query dataSource="${database}" var="result">
	SELECT *
	FROM ${param.table}
</sql:query>
<%-- TODO: limitare il numero di rows lette + aggiungere pulsanti "prev" e "next" --%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<base href="${pageContext.request.scheme}://${pageContext.request.serverName}:${pageContext.request.serverPort}${pageContext.request.contextPath}/" /> 
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - Lista ${param.table}</title>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="../header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="../product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">

<h1>Lista ${param.table}</h1>

<table border="1" width="100%">
    <!-- column headers -->
    <tr>
        <c:forEach var="columnName" items="${result.columnNames}">
            <th><c:out value="${columnName}"/></th>
        </c:forEach>
    </tr>
    <!-- column data -->
    <c:forEach var="row" items="${result.rowsByIndex}">
        <tr>
            <c:forEach var="column" items="${row}">
                <td><c:out value="${column}"/></td>
            </c:forEach>
            <td><b><a href="admin/table_edit_row_form.jsp?table=${param.table}&key=${row[0]}" class="button admin edit">Modifica</a></b></td>
            <td><b><a href="admin/table_del_row.jsp?table=${param.table}&key=${row[0]}" class="button admin del">Cancella</a></b></td>
        </tr>
    </c:forEach>
</table>

<p align="center">
	<b><a href="admin/table_edit_row_form.jsp?table=${param.table}" class="button admin add">Aggiungi nuovo</a></b>
</p>

  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="../footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
