<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="../error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>

<%-- controllo di sicurezza: impedisce l'accesso agli altri utenti --%>
<c:if test="${not (sessionScope.username == 'admin')}">
   	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato ad accedere a questa pagina" />
   	<jsp:forward page="../error.jsp" />
</c:if>

<c:if test="${empty param.table}">
   	<c:set var="errorMessage" scope="request" value="Nessuna tabella specificata" />
   	<jsp:forward page="../error.jsp" />
</c:if>

<c:if test="${empty param.key}">
   	<c:set var="errorMessage" scope="request" value="Nessuna riga specificata" />
   	<jsp:forward page="../error.jsp" />
</c:if>


<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />

<sql:query dataSource="${database}" var="result">
	SELECT *
	FROM ${param.table}
	WHERE ID_${param.table} = '${param.key}'
</sql:query>
<c:if test="${empty result.rows}">
	<c:set var="errorMessage" scope="request" value="Item does not exist" />
 	<jsp:forward page="../error.jsp" />
</c:if>


<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<base href="${pageContext.request.scheme}://${pageContext.request.serverName}:${pageContext.request.serverPort}${pageContext.request.contextPath}/" /> 
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - Visualizza ${param.table}</title>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="../header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="../product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">

	<h1>Dettagli ${param.table}:</h1>

   <c:forEach var="columnName" items="${result.columnNames}">
   		<b><c:out value="${columnName}"/>:</b> <c:out value="${result.rows[0][columnName]}"/><br>
   </c:forEach>
   
   <br>
   <a href="admin/table_edit_row_form.jsp?table=${param.table}&key=${param.key}" class="button edit">Modifica</a>
   <a href="admin/table_del_row.jsp?table=${param.table}&key=${param.key}" class="button del">Cancella</a>
            
  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="../footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
