<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />
     
<c:if test="${not (empty param.addpid)}">	 
	<%-- c:set var="cart_pid_${param.addpid}" scope="session" value="${(param.q)?(param.q):1}" / --%>
	<% session.setAttribute(("cart_pid_"+request.getParameter("addpid")), ((request.getParameter("q")!=null)?(request.getParameter("q")):"1")); %>
</c:if>

<c:if test="${not (empty param.delpid)}">	 
	<%-- c:remove var="cart_pid_${param.delpid}" scope="session" / --%>
	<% session.removeAttribute("cart_pid_" + request.getParameter("delpid")); %>
</c:if>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - carrello</title>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">
  
    <h1>Carrello</h1>
    
	<%--form action="cart.jsp" method="POST" --%>
	<table border="1" width="100%">
		<tr>
			<th width="75%">Prodotto</th>
			<th>Costo</th>
			<th>Quantità</th>
			<th></th>
		</tr>
		
		<c:set var="totale" scope="page" value="0"/>
		<c:forEach var="item" items="${sessionScope}"> <%-- cicla tutte le variabili di sessione --%>
			<c:if test="${fn:startsWith(item.key, 'cart_pid_')}">
				<c:set var="pid" scope="page" value="${fn:substringAfter(item.key, 'cart_pid_')}" />
				<sql:query dataSource="${database}" var="result">
					SELECT Nome,Costo,Immagine
					FROM Prodotto
					WHERE ID_Prodotto = ${pid}
				</sql:query>
				<tr>
					<td>
						<c:if test="${not empty (row.immagine)}">
							<img src="${row.immagine}" alt="anteprima immagine prodotto" class="thumb" />
						</c:if>
						<a href="product_view.jsp?pid=${pid}"><c:out value="${result.rows[0].nome}"/></a>
					</td>
					<td><c:out value="${result.rows[0].costo}"/></td>
					<td><c:out value="${item.value}"/></td>
					<td><a href="cart.jsp?delpid=${pid}" class="button del">Rimuovi</a></td>
				</tr>
				<c:set var="totale" scope="page" value="${(totale+(result.rows[0].costo)*item.value)}"/>	
			</c:if>
		</c:forEach>
		
	</table>
	<%--input type="submit" value="Aggiorna carrello" --%>
		<!-- TODO BUTTONS: svuota carrello, aggiorna quantità -->
	<%--/form --%>

	<c:choose>
		<c:when test="${totale ne 0}">
			<span style="float:right">
			<h2>Totale: <c:out value="${totale}"/> &euro;</h2>
			<a href="order_save.jsp" class="button order send">Invia ordine</a>
			</span>
		</c:when>
		<c:otherwise>
			<b>Il tuo carrello è vuoto!</b>
		</c:otherwise>
	</c:choose>
	
  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
