<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>


<%-- PRE: controlla che l'utente sia loggato --%>
<c:if test="${empty sessionScope.username}">
	<c:set var="errorMessage" scope="request" value="Devi essere loggato per inviare un ordine!" />
	<jsp:forward page="error.jsp" />
</c:if>

<%-- TODO? testare che il carrello non sia vuoto --%>

<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />
     
<%-- legge l'ID_Cliente dell'utente attuale --%>
<sql:query dataSource="${database}" var="uid_result">
    SELECT ID_Cliente
	FROM Cliente
	WHERE username = '${sessionScope.username}';
</sql:query>
<c:set var="ID_Cliente" scope="page" value="${uid_result.rows[0].ID_Cliente}"/>

<%-- genera l'ID dell'ordine --%>
<sql:transaction dataSource="${database}">
	<sql:query var="max_oid_result">
		SELECT MAX(ID_Ordine) AS MAX_ID_Ordine
		FROM Ordine;
	</sql:query>
	<c:set var="ID_Ordine" scope="page" value="${(max_oid_result.rows[0].MAX_ID_Ordine)+1}"/>
	<%-- salva l'ordine con il totale --%>
	<sql:update>
	  	INSERT INTO Ordine (ID_Ordine, ID_Cliente, Stato, Data, Totale)
	  	VALUES ( ${ID_Ordine}, ${ID_Cliente}, 'In attesa di pagamento', CURRENT_TIMESTAMP, 0 );
	</sql:update>
</sql:transaction>

<c:choose>
	<c:when test="${sessionScope.username == 'admin'}">
		<%-- salva direttamente il prodotto richiesto dai parametri --%>
		<sql:update dataSource="${database}">
		  	INSERT INTO Fornitura (ID_Ordine, ID_Prodotto, Quantita, Costo)
		  	VALUES ( ${ID_Ordine}, ${param.pid}, ${param.q}, ${param.costo} );
		</sql:update>
		<c:set var="totale" scope="page" value="${(param.costo*param.q)}"/>
	</c:when>
	<c:otherwise>
		<%-- legge e il contenuto del carrello dalla sessione corrente e associa i prodotti all'ordine --%>
		<c:set var="totale" scope="page" value="0"/>
		<c:forEach var="item" items="${sessionScope}"> <%-- cicla tutte le variabili di sessione --%>
			<c:if test="${fn:startsWith(item.key, 'cart_pid_')}">
				<c:set var="pid" scope="page" value="${fn:substringAfter(item.key, 'cart_pid_')}" />
				<%-- legge il costo dell'item --%>
				<sql:query dataSource="${database}" var="costo_result">
					SELECT Costo
					FROM Prodotto
					WHERE ID_Prodotto = ${pid};
				</sql:query>
				<%-- aggiorna il totale --%>
				<c:set var="totale" scope="page" value="${(totale+(costo_result.rows[0].costo)*item.value)}"/>
				<%-- inserisce l'oggetto nell'ordine --%>
				<sql:update dataSource="${database}">
				  	INSERT INTO Prodotto_Ordinato (ID_Ordine, ID_Prodotto, Quantita, Costo)
				  	VALUES ( ${ID_Ordine}, ${pid}, ${item.value}, ${costo_result.rows[0].costo} );
				</sql:update>
				<%-- rimuove l'oggetto dal carrello --%>
				<% session.removeAttribute("cart_pid_" + pageContext.getAttribute("pid")); %>
				<sql:update dataSource="${database}">
			   		DELETE FROM Carrello
			   		WHERE (ID_Cliente = ${ID_Cliente}) AND (ID_Prodotto = ${pid});
				</sql:update>
				<%-- TODO? decrementa la disponibilità del prodotto acquistato --%>
			</c:if>
		</c:forEach>
	</c:otherwise>
</c:choose>
	
<%-- salva il totale --%>
<sql:update dataSource="${database}">
  	UPDATE Ordine
  	SET Totale=${totale}
  	WHERE ID_Ordine=${ID_Ordine};
</sql:update>
      
<c:choose>
	<c:when test="${sessionScope.username == 'admin'}">
		<c:set var="message" scope="request"><h1>Richiesta di fornitura inviata correttamente</h1><br>Per visualizzare il riepilogo dell'ordine fare click <a href="order_view.jsp?id=${ID_Ordine}">qui</a>.</c:set>
	</c:when>
	<c:otherwise>
		<c:set var="message" scope="request"><h1>Ordine inviato correttamente</h1><br>Controllare la propria email per le informazioni sul pagamento.<br>Per visualizzare il riepilogo dell'ordine fare click <a href="order_view.jsp?id=${ID_Ordine}">qui</a>.</c:set>
	</c:otherwise>
</c:choose>
<jsp:forward page="message.jsp" />
