<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>


<%-- PRE: controlla che l'utente sia loggato --%>
<c:if test="${empty sessionScope.username}">
	<c:set var="errorMessage" scope="request" value="Devi essere loggato per visualizzare il tuo ordine!" />
	<jsp:forward page="error.jsp" />
</c:if>

<%-- PRE: controlla che sia specificato l'ID dell'ordine --%>
<c:if test="${empty param.id}">
	<c:set var="errorMessage" scope="request" value="Nessun ID specificato" />
	<jsp:forward page="error.jsp" />
</c:if>

<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />
     
<%-- legge l'ID_Cliente dell'utente attuale --%>
<sql:query dataSource="${database}" var="uid_result">
    SELECT ID_Cliente
	FROM Cliente
	WHERE username = '${sessionScope.username}';
</sql:query>
<c:set var="ID_Cliente" scope="page" value="${uid_result.rows[0].ID_Cliente}"/>

<%-- legge i dati dell'ordine dal DB --%>
<sql:query dataSource="${database}" var="order_result">
    SELECT *
	FROM Ordine
	WHERE (ID_Ordine = ${param.id})
	<c:if test="${sessionScope.username != 'admin'}"> 
		AND (ID_Cliente = ${ID_Cliente})
	</c:if>
	;
</sql:query>
<c:if test="${empty order_result.rows}">
	<c:set var="errorMessage" scope="request" value="L'utente corrente non è autorizzato a visualizzare questo ordine." />
	<jsp:forward page="error.jsp" />
</c:if>

<%-- legge i dati dei prodotti inclusi nell'ordine --%>
<c:choose>
	<c:when test="${sessionScope.username == 'admin'}">
		<sql:query dataSource="${database}" var="prodotti_ordinati_result">
		    SELECT F.ID_Prodotto, Nome, F.Costo, Quantita
			FROM Fornitura AS F, Prodotto AS P 
			WHERE (ID_Ordine = ${param.id}) AND (F.ID_Prodotto = P.ID_Prodotto);
		</sql:query>
	</c:when>
	<c:otherwise>
		<sql:query dataSource="${database}" var="prodotti_ordinati_result">
		    SELECT O.ID_Prodotto, Nome, O.Costo, Quantita
			FROM Prodotto_Ordinato AS O, Prodotto AS P 
			WHERE (ID_Ordine = ${param.id}) AND (O.ID_Prodotto = P.ID_Prodotto);
		</sql:query>
	</c:otherwise>
</c:choose>


<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - Riepilogo ordine</title>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">
  
  <h1>Riepilogo dell'ordine n. ${param.id}</h1>
  	<h2>Data invio ordine: <c:out value="${order_result.rows[0].Data}"/></h2>
	<h2>Stato: <c:out value="${order_result.rows[0].Stato}"/></h2>
	<h2>Prodotti inclusi:</h2>
		<table border="1" width="100%">
			<tr>
				<th width="75%">Prodotto</th>
				<th width="15%">Costo</th>
				<th>Quantità</th>
			</tr>
			<c:forEach var="row" items="${prodotti_ordinati_result.rows}">
				<tr>
					<td><a href="product_view.jsp?pid=${row.ID_Prodotto}"><c:out value="${row.Nome}"/></a></td>
					<td><c:out value="${row.Costo}"/> &euro;</td>
					<td><c:out value="${row.Quantita}"/></td>
				</tr>
			</c:forEach>	
		</table>
	<h2>Totale: <c:out value="${order_result.rows[0].Totale}"/> &euro;</h2>

	<c:if test="${sessionScope.username == 'admin'}">
		<a href="admin/table_edit_row_form.jsp?table=Ordine&key=${order_result.rows[0].ID_Ordine}" class="admin button edit">Modifica dati ordine</a>
		<%--TODO? <a href="admin/table_list.jsp?table=Prodotto_Ordinato" class="button edit">Modifica prodotti nell'ordine</a> --%>
		<%--TODO? <a href="admin/table_edit_row_form.jsp?table=Prodotto_Ordinato" class="button edit">Aggiungi prodotto nell'ordine</a> --%>
		<a href="admin/table_del_row.jsp?table=Ordine&key=${order_result.rows[0].ID_Ordine}" class="admin button del">Cancella Ordine</a>
		<%--a href="admin/table_view_row.jsp?table=Cliente&key=${order_result.rows[0].ID_Cliente}" class="admin button profile">Visualizza dati cliente</a --%>
	</c:if>
	
  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
