<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<%-- PRE: controlla che l'utente sia loggato --%>
<c:if test="${empty sessionScope.username}">
	<c:set var="errorMessage" scope="request" value="Devi essere loggato per visualizzare la tua lista ordini." />
	<jsp:forward page="error.jsp" />
</c:if>

<sql:setDataSource var="database"
	 driver="${initParam.databaseDriver}"
	 url="${initParam.databaseUrl}/${initParam.shopName}"
	 user="${initParam.databaseUsername}"
	 password="${initParam.databasePassword}" />
	 
<c:choose>
	<c:when test="${sessionScope.username == 'admin'}">
		<%-- mostra solo le forniture --%>
		<sql:query dataSource="${database}" var="result">
		    SELECT *
			FROM Ordine
			WHERE ID_Cliente = 1;
		</sql:query>
		<%-- TODO: limita la query solo agli ordini più recenti + mostra pulsanti "prev", "next" --%>
	</c:when>
	<c:otherwise>
		<%-- mostra solo gli ordini dell'utente corrente --%>
		<sql:query dataSource="${database}" var="result">
		    SELECT *
			FROM Ordine
			WHERE ID_Cliente = ( SELECT ID_Cliente
			             		 FROM Cliente
								 WHERE username = '${sessionScope.username}'
			                    );
		</sql:query>
	</c:otherwise>
</c:choose>

<c:if test="${empty result.rows}">
	<c:set var="message" scope="request" value="<h1>Lista ordini</h1><br>Nessun ordine da visualizzare." />
   	<jsp:forward page="message.jsp" />
</c:if>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - Lista ordini</title>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="header.inc.jsp" %>
  <!-- end .header --></div>
  <c:if test="${sessionScope.username != 'admin'}">
  	<div class="cat-menu">
  		<%@ include file="product_cat_list.inc.jsp" %>
  	</div>
  </c:if>
  <div class="content">

	<c:if test="${sessionScope.username == 'admin'}">
		<h1>Lista forniture</h1>
		<table border="1" width="100%">
			<tr>
				<th>ID Ordine</th>
				<th>Stato</th>
				<th>Data</th>
				<th>Totale</th>
			</tr>
			<c:forEach var="row" items="${result.rows}">
				<tr>
					<td><a href="order_view.jsp?id=${row.ID_Ordine}">${row.ID_Ordine}</a></td>
					<td><c:out value="${row.Stato}"/></td>
					<td><c:out value="${row.Data}"/></td>
					<td><c:out value="${row.Totale}"/> &euro;</td>
					<td><a href="admin/table_edit_row_form.jsp?table=Ordine&key=${row.ID_Ordine}" class="admin button edit">Modifica</a></td>
					<td><a href="admin/table_del_row.jsp?table=Ordine&key=${row.ID_Ordine}" class="admin button del">Cancella</a></td>
				</tr>
			</c:forEach>	
		</table>
		<br>
		
		<%-- mostra tutti gli altri ordini nel DB --%>
		<sql:query dataSource="${database}" var="result">
		    SELECT *
			FROM Ordine
			WHERE ID_Cliente <> 1;
		</sql:query>
	</c:if>
			
	<h1>Lista ordini</h1>
	<table border="1" width="100%">
		<tr>
			<th>ID Ordine</th>
			<c:if test="${sessionScope.username == 'admin'}">
				<th>ID Cliente</th>
			</c:if>
			<th>Stato</th>
			<th>Data</th>
			<th>Totale</th>
		</tr>
		<c:forEach var="row" items="${result.rows}">
			<tr>
				<td><a href="order_view.jsp?id=${row.ID_Ordine}">${row.ID_Ordine}</a></td>
				<c:if test="${sessionScope.username == 'admin'}">
					<td><a href="admin/table_view_row.jsp?table=Cliente&key=${row.ID_Cliente}">${row.ID_Cliente}</a></td>
				</c:if>
				<td><c:out value="${row.Stato}"/></td>
				<td><c:out value="${row.Data}"/></td>
				<td><c:out value="${row.Totale}"/> &euro;</td>
				<c:if test="${sessionScope.username == 'admin'}">
					<td><a href="admin/table_edit_row_form.jsp?table=Ordine&key=${row.ID_Ordine}" class="admin button edit">Modifica</a></td>
					<td><a href="admin/table_del_row.jsp?table=Ordine&key=${row.ID_Ordine}" class="admin button del">Cancella</a></td>
				</c:if>
			</tr>
		</c:forEach>	
	</table>
  	
  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
