<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>


<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />

<sql:query dataSource="${database}" var="prod_result">
	SELECT ID_Prodotto, Nome, Costo, Immagine
	FROM Prodotto
	WHERE ID_Prodotto IN (
							<c:forEach var="p" items="${paramValues.pid}">
			                      	${p},
			                </c:forEach>
			                 0	
			              )
</sql:query>
<c:if test="${fn:length(prod_result.rows) < 2}">
	<c:set var="errorMessage" scope="request" value="Numero di prodotti selezionati insufficiente" />
   	<jsp:forward page="error.jsp" />
</c:if>

<%-- trova le caratteristiche di tutti i prodotti --%>
<sql:query dataSource="${database}" var="feat_result">
	SELECT DISTINCT C.ID_Caratteristica AS ID_Caratteristica, Nome
	FROM Caratteristica AS C, CaratterizzaProdotto AS CP
	WHERE (C.ID_Caratteristica = CP.ID_Caratteristica) AND (CP.ID_Prodotto IN (
						<c:forEach var="p" items="${paramValues.pid}">
		                      	${p},
		                </c:forEach>
		                 0	
		              ) )
</sql:query>


			                      
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - Confronto prodotti</title>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="product_cat_list.inc.jsp" %>
  	</div>
  	
  <div class="content">

	<h1>Confronto prodotti</h1>
	
			<table width="100%" border="2">
			
				<tr>
					<th></th>
					<c:forEach var="row" items="${prod_result.rows}">						
						<td>
							<c:if test="${not empty (row.immagine)}">
								<img src="${row.immagine}" alt="anteprima immagine prodotto" class="thumb" />
							</c:if>
							<a href="product_view.jsp?pid=${row.ID_Prodotto}">
								<c:out value="${row.nome}"/>
							</a>
						</td>
					</c:forEach>
				</tr>
				
				<tr>
					<th>Costo</th>
					<c:forEach var="row" items="${prod_result.rows}">						
						<td><c:out value="${row.costo}"/> &euro;</td>
					</c:forEach>
				</tr>
		
				<c:forEach var="feature" items="${feat_result.rows}">
					<tr> <%-- TODO: cambiare colore background a seconda se i valori sono uguali o diversi (mette in risalto le differenze tra i prodotti) --%>
						<th>${feature.nome}</th>
						
						<c:forEach var="p" items="${prod_result.rows}">
						<td>
							<sql:query dataSource="${database}" var="check_result">
								SELECT Grandezza
								FROM CaratterizzaProdotto
								WHERE (ID_Caratteristica = ${feature.ID_Caratteristica}) AND (ID_Prodotto = ${p.ID_Prodotto})
							</sql:query>
							<c:choose>
								<c:when test="${empty check_result.rows}">
								   no
								</c:when>
								<c:when test="${empty check_result.rows[0].Grandezza}">
								   si
								</c:when>
								<c:otherwise>
									<c:forEach var="feat" items="${check_result.rows}">
										<c:out value="${feat.Grandezza}"/> 
									</c:forEach>
								</c:otherwise>
							</c:choose>
						</td>
						</c:forEach>
					</tr>
				</c:forEach>	
									
			</table>
	
  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
