<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>


<c:if test="${(not empty param.keywords) and (fn:length(param.keywords) <= 3)}">
	<c:set var="errorMessage" scope="request" value="Parole chiave di ricerca non valide" />
   	<jsp:forward page="error.jsp" />
</c:if>

<sql:setDataSource var="database"
	 driver="${initParam.databaseDriver}"
	 url="${initParam.databaseUrl}/${initParam.shopName}"
	 user="${initParam.databaseUsername}"
	 password="${initParam.databasePassword}" />
	 
<!-- TODO? tokenizzare le keywords per la ricerca, consentire parametro request: ORDER BY Costo, etc. -->
<sql:query dataSource="${database}" var="result">
	SELECT ID_Prodotto, Nome, Costo, Disponibile, Immagine
	FROM Prodotto
	WHERE
	<c:if test="${not empty param.keywords}">
		<c:choose>
			<c:when test="${initParam.databaseDriver == 'com.mysql.jdbc.Driver'}">
				<%-- MySQL --%>
			    ( MATCH (Nome, Descrizione) AGAINST ('${param.keywords}' IN BOOLEAN MODE) ) AND
			</c:when>
			<c:otherwise>
				( LOWER(Nome) LIKE LOWER('%${param.keywords}%') ) AND
			</c:otherwise>
		</c:choose>
	</c:if>
	<c:if test="${not empty param.cat}">
		( ID_Classe = ${param.cat} ) AND
	</c:if>
	<c:if test="${not empty param.features}">
		( ID_Prodotto = ANY ( 
							  SELECT ID_Prodotto
		                      FROM CaratterizzaProdotto
		                      WHERE (
			                      <c:forEach var="feature" items="${paramValues.features}">
									<c:choose>
										<c:when test="${empty (fn:substringBefore(feature, '='))}">
										   ( ID_Caratteristica = ${feature} ) OR
										</c:when>
										<c:otherwise>
											( ID_Caratteristica = ${fn:substringBefore(feature, '=')} AND
											  Grandezza = '${fn:substringAfter(feature, '=')}'
											) OR
										</c:otherwise>
									</c:choose>			                      
			                      </c:forEach>	
			                        FALSE <%-- termina la lista --%>
		                     	 )
		                     ) <%-- 2FIX: multiple features check --%>
		) AND
	</c:if>
	TRUE
	ORDER BY Disponibile DESC
</sql:query>
	
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - Ricerca ${param.keywords}</title>
</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">

	<c:if test="${not empty param.cat}">
		<sql:query dataSource="${database}" var="classname_result">
			SELECT Nome
			FROM Classe
			WHERE ID_Classe = ${param.cat}
		</sql:query>
		<h1>Categoria: ${classname_result.rows[0].Nome}</h1>
		
		<p align="center">
		<form method="GET" action="product_search.jsp">
			parole chiave: <input type="text" name="keywords" value="${param.keywords}">
			<br>
			<input type="hidden" name="cat" value="${param.cat}">
			<br>
			caratteristiche:<br>
			<%--@ include file="feat_list_form.inc.jsp" --%>
			<%-- 
				<sql:query dataSource="${database}" var="feat_result">
					SELECT C.ID_Caratteristica, Nome
					FROM Caratteristica AS C, CaratterizzaClasse AS CC
					WHERE (C.ID_Caratteristica = CC.ID_Caratteristica) AND (CC.ID_Classe = ${param.cat})
				</sql:query>
			--%>
				<sql:query dataSource="${database}" var="feat_result">
					SELECT DISTINCT C.ID_Caratteristica, C.Nome, CP.Grandezza AS Grandezza
					FROM Caratteristica AS C, CaratterizzaProdotto AS CP, CaratterizzaClasse AS CC
					WHERE (C.ID_Caratteristica = CP.ID_Caratteristica) AND (CP.ID_Prodotto IN (
																				SELECT ID_Prodotto
																				FROM Prodotto
																				WHERE ID_Classe = ${param.cat} 
																			)
																		AND ( C.ID_Caratteristica = CC.ID_Caratteristica )
																		AND ( CC.ID_Classe = ${param.cat} )
							)
				</sql:query>
			
				<c:if test="${empty feat_result.rows}">
					(nessuna)
				</c:if>
				<c:forEach var="row" items="${feat_result.rows}">
				 	<%-- controlla se la feature corrente è stata selezionata --%>
					 	<c:set var="checked" value="false" />
						<c:forEach var="feature" items="${paramValues.features}">
			            	<c:set var="fullFeature" value="${row.ID_Caratteristica}=${row.grandezza}"/>
			            	<c:if test="${feature == fullFeature}">
					  			<c:set var="checked" value="true" />
					  		</c:if>
			            </c:forEach>
					 <input type="checkbox" name="features" value="${row.ID_Caratteristica}=${row.grandezza}" ${(checked)? 'checked="checked"':''} />
					 <c:out value="${row.nome}" />
					 <c:if test="${not empty row.grandezza}">
	   					: <c:out value="${row.grandezza}"/>
	   				 </c:if>
	   				 <br>
				</c:forEach>
			<br>
			<input type="submit" value="Affina ricerca" class="button search" style="size: 50%;">
		</form>
		</p>
	</c:if>
		
	<hr>
			  
	<h2>Risultati ricerca</h2>
	
	<c:choose>
		<c:when test="${empty result.rows}">
		   <br>Nessun prodotto trovato
		</c:when>
		<c:otherwise>
			<c:if test="${not empty param.keywords}">
			</c:if>
			Prodotti trovati: ${fn:length(result.rows)}
			<br></br>
			<%@ include file="product_list.inc.jsp" %>
		</c:otherwise>
	</c:choose>
  	
  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
