<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>


<c:if test="${empty param.pid}">
  	<c:set var="errorMessage" scope="request" value="Nessun prodotto specificato." />
   	<jsp:forward page="error.jsp" />
</c:if>

<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}?useUnicode=yes&characterEncoding=UTF-8"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />
     
<sql:query dataSource="${database}" var="result">
	SELECT *
	FROM Prodotto
	WHERE ID_Prodotto = ${param.pid}
</sql:query>

<c:if test="${empty result.rows}">
  	<c:set var="errorMessage" scope="request" value="Prodotto non più nel database." />
   	<jsp:forward page="error.jsp" />
</c:if>
	
<c:set var="nome" scope="page" value="${result.rows[0].nome}"/>
<c:set var="costo" scope="page" value="${result.rows[0].costo}"/>
<c:set var="disponibile" scope="page" value="${result.rows[0].disponibile}"/>


<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<title>${initParam.shopName} - Dettagli prodotto - ${nome}</title>

<%-- TODO: VALUTARE ALTERNATIVA http://www.quirksmode.org/dom/error.html --%>
<script language="JavaScript" type="text/javascript">
<!--
function validate( form )
{
  // see http://www.thesitewizard.com/archive/validation.shtml
  // for an explanation of this script and how to use it on your
  // own website

  if (isNaN(form.q.value)) {
    alert( "Quantità specificata non valida." );
    form.q.focus();
    return false ;
  }
  if (form.q.value <= 0) {
    alert( "Quantità specificata non valida." );
    form.q.focus();
    return false ;
  }
  if (form.q.value > ${disponibile}) {
	    alert( "Quantità specificata superiore alla disponibilità." );
	    form.q.focus();
	    return false ;
  }
 
  return true ;
}


function getVideoPreview( url, size )
{
	/* TODO: aggiungere supporto ad altri siti oltre youtube */
	
  if(url === null){ return ""; }

  size = (size === null) ? "small" : size;
  var vid;
  var results;

  results = url.match("[\\?&]v=([^&#]*)");
  
  vid = ( results === null ) ? url : results[1];

  if(size == "small"){
    return "http://img.youtube.com/vi/"+vid+"/2.jpg";
  } else {
    return "http://img.youtube.com/vi/"+vid+"/0.jpg";
  }
}
//-->
</script>

</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="header.inc.jsp" %>
  <!-- end .header --></div>
  	<div class="cat-menu">
  		<%@ include file="product_cat_list.inc.jsp" %>
  	</div>
  <div class="content">
   
 	<h1><c:out value="${nome}"/></h1>	
  	<h2>
  	<c:if test="${not empty (result.rows[0].immagine)}">
 		<img src="${result.rows[0].immagine}" alt="immagine prodotto principale">
 		<br></br>
 	</c:if>
	
	<%-- altre immagini --%>
		<c:if test="${not empty (result.rows[0].immagine2)}">
	 		<a href="${result.rows[0].immagine2}" target="_blank"><img src="${result.rows[0].immagine2}" alt="anteprima immagine prodotto 2" class="thumb"/></a>
	 	</c:if>
	 	<c:if test="${not empty (result.rows[0].immagine3)}">
	 		<a href="${result.rows[0].immagine3}" target="_blank"><img src="${result.rows[0].immagine3}" alt="anteprima immagine prodotto 3" class="thumb"/></a>
	 	</c:if>
	 	<c:if test="${not empty (result.rows[0].immagine4)}">
	 		<a href="${result.rows[0].immagine4}" target="_blank"><img src="${result.rows[0].immagine4}" alt="anteprima immagine prodotto 4" class="thumb"/></a>
	 	</c:if>
	 	<c:if test="${not empty (result.rows[0].immagine5)}">
	 		<a href="${result.rows[0].immagine5}" target="_blank"><img src="${result.rows[0].immagine5}" alt="anteprima immagine prodotto 5" class="thumb"/></a>
	 	</c:if>
		<c:if test="${not empty (result.rows[0].Video)}">
		<%--Video: --%>
			<a href="${result.rows[0].Video}" target="_blank">
			<script type="text/javascript">document.write('<img src="' + getVideoPreview('${result.rows[0].Video}') + '" alt="anteprima video" class="thumb" />');</script>
			<%-- SINTASSI ALTERNATIVA? <img src="javascript:getVideoPreview('${result.rows[0].Video}')" alt="anteprima video" class="thumb"/> --%>
			</a><br>
		</c:if>
	</h2>
	
	<h2>Prezzo: ${costo} &euro;</h2>
	<h3>
	<c:choose>
	    <c:when test="${disponibile>0}">
	       Disponibilità: ${disponibile}
	       <br>
	       <c:if test="${not (sessionScope.username == 'admin')}">
			    <form method="POST" action="cart.jsp" onsubmit="return validate(this)">
					<input type="submit" value="Aggiungi al carrello" class="button cart">
			        <input type="hidden" name="addpid" value="${param.pid}">
					quantità: <input type="text" name="q" value="1" size="4">
				</form>
			</c:if>
	    </c:when>
	    <c:otherwise>
	        Prodotto attualmente non disponibile
	    </c:otherwise>
	</c:choose>
	</h3>
	
	<c:if test="${not empty (result.rows[0].ID_Classe)}">
		<%-- TODO? incorporare questa query in quella precedente --%>
		<sql:query dataSource="${database}" var="classe_result">
			SELECT Nome
			FROM Classe
			WHERE ID_Classe = ${result.rows[0].ID_Classe}
		</sql:query>
	</c:if>
	<h3>Classe merceologica: 
	<c:choose>
		<c:when test="${empty (classe_result.rows[0].Nome)}">
		   nessuna
		</c:when>
		<c:otherwise>
			<%--<a href="product_browse.jsp?cat=${result.rows[0].ID_Classe}"><c:out value="${(classe_result.rows[0].Nome)}"/></a> --%>
			<a href="product_search.jsp?cat=${result.rows[0].ID_Classe}"><c:out value="${(classe_result.rows[0].Nome)}"/></a>
		</c:otherwise>
	</c:choose>
	</h3>

	<%-- solo per admin, mostra anche il fornitore e alcuni pulsanti di amministrazione --%>
	<c:if test="${sessionScope.username == 'admin'}">
		<c:if test="${not empty (result.rows[0].ID_Fornitore)}">
			<%-- TODO? incorporare questa query in quella precedente --%>
			<sql:query dataSource="${database}" var="fornitore_result">
				SELECT Nome
				FROM Fornitore
				WHERE ID_Fornitore = ${result.rows[0].ID_Fornitore}
			</sql:query>
		</c:if>
		<h3>Fornitore: 
		<c:choose>
			<c:when test="${empty (fornitore_result.rows[0].Nome)}">
			   nessuno
			</c:when>
			<c:otherwise>
				<a href="admin/table_view_row.jsp?table=Fornitore&key=${result.rows[0].ID_Fornitore}"><c:out value="${(fornitore_result.rows[0].Nome)}"/></a>
			</c:otherwise>
		</c:choose>		
		</h3>
		<a href="admin/product_edit_form.jsp?pid=${param.pid}" class="admin button edit">Modifica scheda prodotto</a>
		<a href="admin/table_del_row.jsp?table=Prodotto&key=${param.pid}" class="admin button del">Rimuovi prodotto</a>
		<form action="order_save.jsp" method="POST">
			<input type="submit" value="Richiedi fornitura" class="admin button order">
			<input type="hidden" name="pid" value="${param.pid}">
			costo unitario: <input type="text" name="costo" value="0" size="4">
			quantità: <input type="text" name="q" value="1" size="4">
		</form>
		<br></br>
	</c:if>
	 		
	<p style="text-align: left;"><c:out value="${result.rows[0].descrizione}" escapeXml="false" /></p>
	
	<sql:query dataSource="${database}" var="features_result">
		SELECT C.ID_Caratteristica, Nome, Grandezza
		FROM Caratteristica AS C, CaratterizzaProdotto AS CP
		WHERE (C.ID_Caratteristica = CP.ID_Caratteristica) AND (CP.ID_Prodotto = ${param.pid})
	</sql:query>
	<c:if test="${not empty features_result.rows}">
	  	<b>Caratteristiche:</b>
	  	<ul>
	   	<c:forEach var="feature" items="${features_result.rows}">
	   		<li>${feature.nome}
	   			<c:if test="${not empty feature.grandezza}">
	   				: <c:out value="${feature.grandezza}"/>
	   			</c:if>
	   		</li>
	   	</c:forEach>
	   	</ul>
	   	<br></br>
	</c:if>
	
	<c:if test="${not empty (result.rows[0].URL)}">
		<b>Link esterno:</b> <u><a href="${result.rows[0].URL}">${result.rows[0].URL}</a></u>
	</c:if>
	<br></br>
	
	<c:if test="${not empty result.rows[0].ID_Classe}"> <%-- controlla che il prodotto ha una classe associata --%>
	 	<hr>
	 	<b>Prodotti simili:</b>
	 	<%-- seleziona gli altri prodotti della stessa classe con le stesse caratteristiche --%>
		<sql:query dataSource="${database}" var="result">
			SELECT ID_Prodotto, Nome, Costo, Disponibile, Immagine
			FROM Prodotto
			WHERE (ID_Prodotto <> ${param.pid}) AND
			      (ID_Classe = ${result.rows[0].ID_Classe}) AND
			      (ID_Prodotto IN (
			      					SELECT ID_Prodotto
			      					FROM CaratterizzaProdotto
			      					WHERE ( ID_Caratteristica IN ( SELECT ID_Caratteristica FROM CaratterizzaClasse WHERE ID_Classe = ${result.rows[0].ID_Classe}) AND
			      						(
			      						<c:forEach var="feature" items="${features_result.rows}">
										<c:choose>
											<c:when test="${empty feature.grandezza}">
											   ( ID_Caratteristica = ${feature.ID_Caratteristica} ) OR
											</c:when>
											<c:otherwise>
												( ID_Caratteristica = ${feature.ID_Caratteristica} AND
												  Grandezza = '${feature.Grandezza}'
												) OR
											</c:otherwise>
										</c:choose>
										</c:forEach>
										FALSE
										)
			      					)
			                   )	   	
			      )
			LIMIT 3
		</sql:query>
			<c:choose>
				<c:when test="${empty result.rows}">
				   <p align="center">Nessun prodotto trovato</p>
				</c:when>
				<c:otherwise>
					<%@ include file="product_list.inc.jsp" %>
				</c:otherwise>
			</c:choose>
	</c:if>

  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>