<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>

<c:if test="${not (empty sessionScope.username)}">
	<%-- legge i dati dell'utente corrente dal DB --%>
	
	<sql:setDataSource var="database"
	     driver="${initParam.databaseDriver}"
	     url="${initParam.databaseUrl}/${initParam.shopName}"
	     user="${initParam.databaseUsername}"
	     password="${initParam.databasePassword}" />
	     
	<sql:query dataSource="${database}" var="result">
		SELECT *
		FROM Cliente
		WHERE username = '${sessionScope.username}'
	</sql:query>
	
	<c:if test="${empty result.rows}">
	  	<c:set var="errorMessage" scope="request" value="Utente non più nel database." />
   	    <jsp:forward page="error.jsp" />
	</c:if>
		
	<c:set var="nome" scope="page" value="${result.rows[0].nome}"/>
	<c:set var="cognome" scope="page" value="${result.rows[0].cognome}"/>
	<c:set var="indirizzo" scope="page" value="${result.rows[0].indirizzo}"/>
	<c:set var="email" scope="page" value="${result.rows[0].email}"/>
	<c:set var="password" scope="page" value="${result.rows[0].password}"/>	
</c:if>
<%-- altrimenti i dati restano non inizializzati! --%>


<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link href="theme/style.css" rel="stylesheet" type="text/css">
<c:choose>
	<c:when test="${not (empty sessionScope.username)}">
	   <title>${initParam.shopName} - Modifica profilo utente</title>
	</c:when>
	<c:otherwise>
		<title>${initParam.shopName} - Registra nuovo utente</title>
	</c:otherwise>
</c:choose>

</head>
<body>

<div class="container">
  <div class="header">
  	<%@ include file="header.inc.jsp" %>
  <!-- end .header --></div>
  <div class="content"> 
    	
    <h1>
    <c:choose>
		<c:when test="${not (empty sessionScope.username)}">
		   Modifica profilo utente
		</c:when>
		<c:otherwise>
			Registra nuovo utente
		</c:otherwise>
	</c:choose>
	</h1>
	
	<script language="JavaScript" type="text/javascript">
	<!--
	function validate( form )
	{
	  // see http://www.thesitewizard.com/archive/validation.shtml
	  // for an explanation of this script and how to use it on your
	  // own website
	
	  // controlla che i campi non siano vuoti o pieni di spazi
	  
		if(form.nome.value.replace(/\s/g,"") == ""){
		    alert( "campo \"Nome\" vuoto" );
		    form.nome.focus();
		    return false ;
		}
		if(form.cognome.value.replace(/\s/g,"") == ""){
		    alert( "campo \"Cognome\" vuoto" );
		    form.cognome.focus();
		    return false ;
		}
		if(form.indirizzo.value.replace(/\s/g,"") == ""){
		    alert( "campo \"Indirizzo\" vuoto" );
		    form.indirizzo.focus();
		    return false ;
		}
		if(form.email.value.replace(/\s/g,"") == ""){
		    alert( "campo \"email\" vuoto" );
		    form.email.focus();
		    return false ;
		}
		// controlla il campo username solo se si sta registrando un nuovo utente
		username=form.username.value.replace(/\s/g,"");
		if("${sessionScope.username}"=="" && (username == "")) {
			
		    alert( "campo \"username\" vuoto" );
		    form.username.focus();
		    return false ;
		}
		password=form.password.value.replace(/\s/g,"");
		if(password == ""){
		    alert( "campo \"password\" vuoto" );
		    form.password.focus();
		    return false ;
		}
	
		// controlla validità password
		if(password.length < 5){
		    alert( "lunghezza minima password: 5 caratteri" );
		    form.password.focus();
		    return false ;
		}
		if(username == password){
		    alert( "la password non può coincidere con l'username" );
		    form.password.focus();
		    return false ;
		}
	 
	  return true ;
	}
	//-->
	</script>

    <form method="POST" action="user_save.jsp" onsubmit="return validate(this)">
    	Nome: <input type="text" name="nome" value="${nome}" maxlength="255"><br>
    	Cognome: <input type="text" name="cognome" value="${cognome}" maxlength="255"><br>
    	Indirizzo: <textarea name="indirizzo" maxlength="255">${indirizzo}</textarea><br>
    	email: <input type="text" name="email" value="${email}" maxlength="255"><br>

		<c:choose>
			<c:when test="${not (empty sessionScope.username)}">
			   <%-- modifica profilo --%>
			   username: <c:out value="${sessionScope.username}"/><br>
			</c:when>
			<c:otherwise>
				<%-- prima registrazione --%>
				username: <input type="text" name="username" value="${username}" maxlength="255" /><br>
			</c:otherwise>
		</c:choose>
		
		password: <input type="password" name="password" value="${password}" maxlength="255" /><br>
    	<%-- TODO: aggiungere campo "Ripeti password" + javascript che controlla matching --%>
    	
		<input type="submit" value="Salva" class="button save">
		<input type="reset" value="Annulla modifiche" class="button cancel"><br>
	</form>
	
	<b>N.B.: TUTTI I CAMPI SONO RICHIESTI!</b>
	
  <!-- end .content --></div>
  <div class="footer">
  	<%@ include file="footer.inc.jsp" %>
  <!-- end .footer --></div>
  <!-- end .container --></div>

</body>
</html>
