<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page isELIgnored="false" %>
<%@ page errorPage="error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>


<%-- PRE: controlla che l'utente sia loggato --%>
<c:if test="${empty sessionScope.username}">
	<c:set var="errorMessage" scope="request" value="utente non loggato." />
	<jsp:forward page="error.jsp" />
</c:if>

<%-- salvataggio carrello nel DB --%>
<sql:setDataSource var="database"
     driver="${initParam.databaseDriver}"
     url="${initParam.databaseUrl}/${initParam.shopName}"
     user="${initParam.databaseUsername}"
     password="${initParam.databasePassword}" />
     
<%-- cancella il contenuto precedente del carrello --%>
<sql:update dataSource="${database}">
		DELETE FROM Carrello
		WHERE ID_Cliente = (
  		 	SELECT ID_Cliente
			FROM Cliente
			WHERE username = '${sessionScope.username}'
			);
</sql:update>	
<%-- cicla tutte le variabili di sessione ed inserisce tutti i prodotti nel carrello --%>
<c:forEach var="item" items="${sessionScope}">
	<c:if test="${fn:startsWith(item.key, 'cart_pid_')}">
		<c:set var="pid" scope="page" value="${fn:substringAfter(item.key, 'cart_pid_')}" />
		<sql:update dataSource="${database}">
	   		INSERT INTO Carrello
	   		 VALUES ( (
	   		 	SELECT ID_Cliente
				FROM Cliente
				WHERE username = '${sessionScope.username}'
				), ${pid}, ${item.value} );
		</sql:update>	
	</c:if>
</c:forEach>
      
<% application.log("user \"" + session.getAttribute("username") + "\" logout."); %>
<%--c:remove var="username"/ --%>
<% session.invalidate(); %>

<c:set var="message" scope="request" value="<h1>Logout eseguito</h1><br>Sessione terminata correttamente.<br>I prodotti presenti nel tuo carrello sono stati salvati." />
<jsp:forward page="message.jsp" />
